local MovePlayer = class("MovePlayer", System)

function MovePlayer:initialize()
  System.initialize(self)
end

function MovePlayer:update(dt)
  --local sprites = self.map.layers["Sprites"].sprites
  for _, entity in pairs(self.targets) do
    local movableComp = entity:get("Movable")
    local playableComp = entity:get("Playable")
    if playableComp.control.moveUp then
      movableComp.fDirection = "u"
    elseif playableComp.control.moveDown then
      movableComp.fDirection = "d"
    elseif playableComp.control.moveLeft then
      movableComp.fDirection = "l"
    elseif playableComp.control.moveRight then
      movableComp.fDirection = "r"
    end
  end
end

function MovePlayer:requires()
  return {"Playable"}
end

return MovePlayer
