Debug = class("Debug")
local space = 15
local initialY = 5

function Debug:initialize()
  Debug.textToShow = {}
  Debug.showEdges = false
end

function Debug:setPause()
  Debug.pause = true
end

function Debug:addTextToShow(key, text, persistent)
  Debug.textToShow[key] = {
    text = text,
    persistent = persistent
  }
end

function Debug:varDump(dumpedVar, persistent, offset)
  local persistent = persistent or false
  local spaces = offset or ''

  if type(dumpedVar) == 'table' and offset ~= "         " then
    for key, var in pairs(dumpedVar) do
      sVar = var
      if type(var) == 'table' then
        Debug:addTextToShow(key, '[table]', persistent)
        Debug:varDump(var, persistent, spaces .. '   ')
      else
        sVar = tostring(var)
        Debug:addTextToShow(spaces .. key, sVar, persistent)
      end
    end
  else
    sVar = tostring(dumpedVar)
    Debug:addTextToShow(type(dumpedVar), sVar, persistent)
  end
end

function Debug:displayText()
  y = initialY
  for key,elem in pairs(Debug.textToShow) do
    sText = elem.text
    if (type(elem.text) ~= 'string') then
      sText = tostring(elem.text)
    end
    love.graphics.print(key .. ' : ' .. sText, 5, y);
    y = y + space
  end
end

function Debug:reset()
  for key,elem in pairs(Debug.textToShow) do
    if elem.persistent ~= true then
      Debug.textToShow[key] = nil
    end
  end
  --Debug.textToShow = {}
end

return Debug
